"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

// @todo Add browser support.
var _default = function _default(configuration) {
  var stream = configuration.stream.toUpperCase() === 'STDOUT' ? process.stdout : process.stderr;

  if (!configuration.bufferSize) {
    return {
      flush: function flush() {},
      write: function write(message) {
        stream.write(message + '\n');
      }
    };
  }

  var flush = function flush() {
    if (!global.ROARR.buffer) {
      return;
    }

    var buffer = global.ROARR.buffer;
    global.ROARR.buffer = '';
    stream.write(buffer);
  };

  return {
    flush,
    write: function write(message) {
      global.ROARR.buffer += message + '\n';

      if (global.ROARR.buffer.length > configuration.bufferSize) {
        flush();
      } // @todo Write messages when the event loop is not busy.

    }
  };
};

exports.default = _default;
//# sourceMappingURL=createWriter.js.map